Index: configure.in
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/configure.in,v
retrieving revision 1.24
diff -u -p -b -r1.24 configure.in
--- configure.in	16 Jan 2005 11:16:24 -0000	1.24
+++ configure.in	10 Apr 2005 22:43:20 -0000
@@ -1,9 +1,9 @@
 dnl Process this file with autoconf to produce a configure script.
-dnl $Id: configure.in,v 1.24 2005/01/16 11:16:24 klas Exp $
-AC_PREREQ(2.50)
-AC_INIT(babyftpd)
+dnl $Id: configure.in,v 1.28 2005/03/30 21:10:56 klas Exp $
+AC_PREREQ(2.59)
+AC_INIT
+AC_CONFIG_SRCDIR([babyftpd.cpp])
 AC_LANG(C++)
-AC_CONFIG_SRCDIR(babyftpd.cpp)
 AC_CONFIG_HEADER(config.h)
   
 dnl Checks for programs.
@@ -22,13 +22,43 @@ dnl Checks for header files.
 AC_HEADER_DIRENT
 AC_HEADER_STAT
 AC_HEADER_TIME
-AC_CHECK_HEADERS(fcntl.h sys/time.h syslog.h unistd.h)
+AC_CHECK_HEADERS(fcntl.h sys/time.h syslog.h unistd.h arpa/inet.h)
+
+AC_C_INLINE
+AC_C_CONST
 
 dnl Checks for typedefs, structures, and compiler characteristics.
 AC_TYPE_SIZE_T
 AC_TYPE_UID_T
+AC_TYPE_MODE_T
+AC_TYPE_OFF_T
+AC_TYPE_PID_T
+AC_TYPE_SIGNAL
+
+AC_STRUCT_TM
 
 dnl Checks for library functions.
+AC_FUNC_FORK
+AC_FUNC_CLOSEDIR_VOID
+AC_FUNC_STAT
+AC_FUNC_LSTAT
+AC_FUNC_LSTAT_FOLLOWS_SLASHED_SYMLINK
+AC_FUNC_MALLOC
+AC_FUNC_MEMCMP
+AC_FUNC_SELECT_ARGTYPES
+AC_FUNC_STRFTIME
+AC_HEADER_STDBOOL
+
+AC_CHECK_FUNCS([gethostname])
+AC_CHECK_FUNCS([inet_ntoa])
+AC_CHECK_FUNCS([localtime_r])
+AC_CHECK_FUNCS([memset])
+AC_CHECK_FUNCS([mkdir])
+AC_CHECK_FUNCS([rmdir])
+AC_CHECK_FUNCS([select])
+AC_CHECK_FUNCS([socket])
+AC_CHECK_FUNCS([strndup])
+AC_CHECK_FUNCS([strtoul])
 
 dnl babystuff
 AC_MSG_CHECKING(whether there is a cradle present)
@@ -45,23 +75,23 @@ AC_MSG_RESULT(no (wheew!))
 
 dnl Commandline enabling/disabling
 AC_ARG_ENABLE(tls,
-    [AC_HELP_STRING([--disable-tls],[Disable the use of tls for encryption.])],
+    [AS_HELP_STRING(--disable-tls,Disable the use of tls for encryption.)],
     [ if test "x$enableval" = "xyes"; then
       AC_CHECK_LIB(gnutls, gnutls_dh_params_generate2, 
-      AC_DEFINE(USE_TLS 1,,[tls enable])
+      AC_DEFINE([USE_TLS],[1],[tls enable])
       LIBS="$LIBS -lgnutls"
       )
     fi],
     AC_CHECK_LIB(gnutls, gnutls_dh_params_generate2,
-    AC_DEFINE(USE_TLS 1,,[tls enable])
+    AC_DEFINE([USE_TLS],[1],[tls enable])
     LIBS="$LIBS -lgnutls"
     )
 )
 
 AC_ARG_ENABLE(newls,
-    [AC_HELP_STRING([--enable-newls],[Enable use of new format for list (yyyy-mm-dd hh:mm).])],
+    [AS_HELP_STRING(--enable-newls,Enable use of new format for list (yyyy-mm-dd hh:mm).)],
     [ if test "x$enableval" = "xyes"; then
-      AC_DEFINE(USE_NEWLS 1,,[newls enable])
+      AC_DEFINE([USE_NEWLS],[1],[newls enable])
       fi]
 )
 
@@ -84,7 +114,7 @@ int main(void)
 }
       ]])],[
 AC_MSG_RESULT(no)
-AC_DEFINE(OLD_GCRYPT 1,,[ Define to mark libgcrypt being 1.1.92 or older])
+AC_DEFINE([OLD_GCRYPT],[1],[ Define to mark libgcrypt being 1.1.92 or older])
 ],[AC_MSG_RESULT(yes)
 ],[])
 
@@ -96,4 +126,5 @@ else
   AC_CHECK_LIB(pam, pam_start)
 fi
 
-AC_OUTPUT(Makefile)
+AC_CONFIG_FILES([Makefile])
+AC_OUTPUT
Index: generic.h
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/generic.h,v
retrieving revision 1.76
diff -u -p -b -r1.76 generic.h
--- generic.h	22 Jan 2005 23:06:05 -0000	1.76
+++ generic.h	10 Apr 2005 22:43:20 -0000
@@ -1,5 +1,5 @@
 /////////////////////////////////////////////////////////////////////
-//  $Id: generic.h,v 1.76 2005/01/22 23:06:05 klas Exp $
+//  $Id: generic.h,v 1.92 2005/04/02 11:46:25 klas Exp $
 //
 // Usage: some defines that is important for correct inclusions of
 //        system headers, and all system header includes.
@@ -8,40 +8,42 @@
 //    LICENSE for complete information.
 /////////////////////////////////////////////////////////////////////
 
-#ifndef __GENERIC_H__
-#define __GENERIC_H__
+#ifndef GENERIC_H
+#define GENERIC_H
 
 #define __USE_GNU 1
 
 #include "config.h"
-#include <unistd.h>
 #include <string>
 #include <vector>
 #include <semaphore.h>
+#include <assert.h>
 
-#ifdef __NETINCLS__
+#ifdef NETINCLS
 #include <sys/socket.h>
 #include <arpa/inet.h>
-#endif // __NETINCLS__
+#endif // NETINCLS
 
-#if (!defined(__STRINGTOKENIZER_H__) && !defined(__CONFIGURATION_H__) && !defined(__UTILITIES_H__))
+#if (!defined(STRINGTOKENIZER_H) && !defined(CONFIGURATION_H) && \
+    !defined(UTILITIES_H) && !defined(LOG_H))
 #include <pthread.h>
-#include <cerrno>
 #include <bitset>
 #include <security/pam_appl.h>
+#include <ext/hash_map>
 #ifdef USE_TLS
 #include <gnutls/gnutls.h>
 #endif // USE_TLS
 using std::bitset;
+using __gnu_cxx::hash_map;
+using __gnu_cxx::hash;
 #endif // stuff...
 
-#ifdef __UTILITIES_H__
+#ifdef UTILITIES_H
 #include <sys/stat.h>
-#endif // __UTILITIES_H__
+#endif // UTILITIES_H
 
-#ifdef __BABYFTPD_H__
+#ifdef BABYFTPD_H
 #include <csignal>
-#include <getopt.h>
 #include <sys/stat.h>
 #include <iostream>
 using std::cout;
@@ -51,47 +53,56 @@ using std::endl;
 #include <gcrypt.h>
 #endif // OLD_GCRYPT
 #endif // USE_TLS
-#endif // __BABYFTPD_H__
+#endif // BABYFTPD_H
 
-#ifdef __HANDLER_H__
-#include <csignal>
-#include <netdb.h>
+#ifdef HANDLER_H
 #include <algorithm>
-#endif // __HANDLER_H__
+#endif // HANDLER_H
 
-#ifdef __CONFIGURATION_H__
-#include <sys/utsname.h>
+#ifdef CONFIGURATION_H
 #include <fstream>
-#include <climits>
 #include <pwd.h>
+#include <grp.h>
+#include <getopt.h>
+#include <iostream>
+using std::cout;
+using std::endl;
 using std::ifstream;
-#endif // __CONFIGURATION_H__
+#endif // CONFIGURATION_H
 
-#ifdef __COMMANDS_H__
+#ifdef COMMANDS_H
 #include <pwd.h>
 #include <sys/stat.h>
-#endif // __COMMANDS_H__
+#endif // COMMANDS_H
 
-#ifdef __COMMANDS2_CPP__
+#ifdef COMMANDS2_CPP
 #include <grp.h>
-#include <shadow.h>
-#include <crypt.h>
 #include <dirent.h>
 #include <fcntl.h>
 #include <algorithm>
-#endif // __COMMANDS2_CPP__
+#endif // COMMANDS2_CPP
 
-#ifdef __LOG_H__
+#ifdef LOG_H
 #include <syslog.h>
 #include <fstream>
 using std::ofstream;
 using std::endl;
-#endif // __LOG_H__
+#endif // LOG_H
 
-#ifdef __USER_H__
-#include <security/pam_appl.h>
-#include <security/pam_misc.h>
-#endif // __USER_H__
+#ifdef CONNECTION_H
+#ifdef USE_TLS
+#include <gnutls/x509.h>
+#endif // USE_TLS
+#endif // CONNECTION_H
+
+#ifdef USER_H
+#include <pwd.h>
+#endif // USER_H
+
+#ifdef DATA_H
+#include <fcntl.h>
+#include <unistd.h>
+#endif // DATA_H
 
 using std::string;
 using std::vector;
@@ -103,8 +114,14 @@ class Handler;
 class Commands;
 class Utilities;
 class StringTokenizer;
+class Log;
+class Connection;
+
+const int PWBUF_SIZE = 100;
 
-#define VERSION "CVS: "__DATE__ // XXX remember to change this when releasing...
+// for exit_baby()
+const int EXIT_EARLY = 1;
+const int EXIT_FULL = 2;
 
 #ifndef FTP_LOG
 #define FTP_LOG DAEMON_LOG
Index: tls.cpp
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/tls.cpp,v
retrieving revision 1.1
diff -u -p -b -r1.1 tls.cpp
--- tls.cpp	18 Jan 2005 22:44:37 -0000	1.1
+++ tls.cpp	10 Apr 2005 22:43:20 -0000
@@ -1,5 +1,5 @@
 /////////////////////////////////////////////////////////////////////
-// $Id: tls.cpp,v 1.1 2005/01/18 22:44:37 klas Exp $
+// $Id: tls.cpp,v 1.2 2005/02/14 21:48:27 klas Exp $
 //
 // Shamelessly ripped code from gcrypt.h, modified for c++.
 //   Included when we have new gcrypt and need to tell it how to do
@@ -10,6 +10,7 @@
 //
 ////////////////////////////////////////////////////////////////////
 
+#define TLS_CPP
 #ifndef OLD_GCRYPT
 
 static int gcry_pthread_mutex_init (void **priv)
Index: examples/babyftpd.conf
===================================================================
RCS file: /cvsroot/babyftpd/babyftpd/examples/babyftpd.conf,v
retrieving revision 1.4
diff -u -p -b -r1.4 babyftpd.conf
--- examples/babyftpd.conf	22 Jan 2005 23:06:05 -0000	1.4
+++ examples/babyftpd.conf	10 Apr 2005 22:43:20 -0000
@@ -1,47 +1,75 @@
-# $Id: babyftpd.conf,v 1.4 2005/01/22 23:06:05 klas Exp $
+# $Id: babyftpd.conf,v 1.15 2005/04/02 10:54:03 klas Exp $
 # General section, for... general stuff
 general
 {
   # port 21 - standard ftp port.
   port 21
 
+  # port 20, standard port for outgoing data
+  data_port 20
+
   # admin email
   admin_email you@your.host
 
   # maximum number of control connections.
   connection_limit 100
 
-  # run the lifebeat() every this seconds
-  lifebeat_tick 300
-
-  #TLS stuff
-  tls_key /root/tls_key.pem
-  tls_cert /root/tls_cert.pem
-  tls_ca /root/tls_ca.pem
-  tls_crl /root/tls_crl.pem
-
-  # how often to regenerate diffie-hellman parameters (in seconds)
-  dh_regenerate 3600
-
-  # what user to run the process under?
-  user ftp
+  # run the lifebeat() every this timeunit (supported are second,
+  #  minute, hour and day)
+  # Note: with large number of connections you want a low value here.
+  lifebeat_tick 5 minutes
+
+  # what user and group to run under? (user:group)
+  user ftp:daemon
+
+  # private key for the server
+  tls_key /etc/babyftpd/tls_key.pem
+
+  # the servers cert
+  tls_cert /etc/babyftpd/tls_cert.pem
+
+  # CA file. This should contain your certificate chain. Also any ca
+  #  certificates that may authenticate clients.
+  tls_ca /etc/babyftpd/tls_ca.pem
+
+  # valid crl list, or don't use at all if your site doesn't make use of
+  #  crls.
+  tls_crl /etc/babyftpd/tls_crl.pem
+
+  # how often to regenerate diffie-hellman parameters (in timeunits)
+  #  Note: this is run inside lifebeat().
+  dh_regenerate 1 hour
+
+  # this is the path to an external program that is used to check if a 
+  #  clients cert is allowed to login as that user. is given 4 arguments:
+  #  username, host/ip ca subject, client subject. return 0 if the login 
+  #  is allowed.
+  # Note that the ca certificate in question must be present in the
+  #  tls_ca file.
+  verify_client /etc/babyftpd/verify_client.pl
 }
 
 # user section, for... user stuff
 user
 {
   # and a user general section, for... user general stuff
-  # all options for single users can be used in this section as well, they will then
-  #   affect all users. options on specific users override general options.
+  #  all options for single users can be used in this section as well, they
+  #  will then affect all users. options on specific users override general 
+  #  options.
   general
   {
     # number of control connections/user
     user_limit 5
 
-    # number of simultaneously open data connections/control connection (list & nlst excluded)
+    # number of simultaneously open data connections/control connection
+    #  (list & nlst excluded)
     sim_data 3
 
-    # encryption:
+    # idle time. after no action on the control connection for this time
+    #  the user is booted. (provided there are no active data transfers either)
+    idle 15 minutes
+
+    # encryption (allow/deny/force/force_cert):
     encryption allow
   }
 
@@ -49,7 +77,7 @@ user
   root
   {
     # this useer is not allowed to login
-    noftp 1
+    noftp true
   }
 
   berra
@@ -58,12 +86,15 @@ user
     only_home 1
 
     # this user can only use passive data transfers
-    only_passive 1
+    only_passive true
 
     user_limit 2
 
     # encryption can have several values..
     encryption deny
+
+    # how long can this user be idle? (in timeunits)
+    idle 5 minutes
   }
 }
 
@@ -73,7 +104,7 @@ log
   log_level 3
 
   # by default we want xferlogging
-  xferlog 1
+  xferlog true
 
   # xferlogging go to /var/log/xferlog
   xferlog_file /var/log/xferlog
@@ -89,4 +120,8 @@ log
 
   # thread id on all logging..
   thread_id 1
+
+  # when logging to a file of our own, what time format should be used?
+  # this example is same as syslog, see strftime(3) for variables.
+  time_format %b %e %H:%M:%S
 }
Index: examples/verify_client.pl
===================================================================
RCS file: examples/verify_client.pl
diff -N examples/verify_client.pl
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ examples/verify_client.pl	10 Apr 2005 22:43:20 -0000
@@ -0,0 +1,45 @@
+#!/usr/bin/perl -w
+# $Id: verify_client.pl,v 1.5 2005/04/09 16:03:40 klas Exp $
+
+# small example script included with babyftpd to show how you can match
+# certificates to usernames. The certificate is already validated against your
+# loaded ca's, this is just to check the mapping to user.
+
+# the daemon will give us 4 commandline parameters:
+#   username of the user attempting to login
+#   hostname or ip of the client
+#            (yes, it can be either, at the time of writing it is always ip
+#            but I mean to fix that.)
+#   dn of the ca that has issued the certificate that is used
+#   dn of the certificate
+
+# Note1: this example doesn't make use of hostname or ca dn. (args 2 and 3).
+
+# Note2: this way of matching dn -> user only allows for each dn to be used
+#        once. If you want to be able to allow a certificate to login as
+#        several users you need to come up with something more clever.
+
+use strict;
+
+(scalar(@ARGV) == 4) or die;
+
+my $user;
+my $hostname;
+my $ca_dn;
+my $user_dn;
+
+($user, $hostname, $ca_dn, $user_dn) = @ARGV;
+
+my %users =
+(
+  "C=SE,O=gablorg,CN=berra Bertil Bertilsson,UID=1001" => "berra",
+  "C=SE,O=gablorg,CN=bosse Bo Bergman,UID=1002" => "bosse",
+);
+my $exit = 1;
+
+if(defined($users{$user_dn}) && $users{$user_dn} eq $user)
+{
+  $exit = 0;
+}
+
+exit $exit;
